import pandas as pd
import numpy as np

#configration
import sys
#import cPickle as pickle

import pyNN.nest as sim

#EXAMPLE_TIME = 30.0
EXAMPLE_TIME = 50.0
NUMBER_TRAINING_EPOCHS = 5
#NUMBER_TRAINING_EPOCHS = 6
#NUMBER_TRAINING_EPOCHS = 7
if (EXAMPLE_TIME == 30.0):
    RUN_DURATION = 15000 #30
    END_OF_TRAINING = 12000 
elif ((EXAMPLE_TIME == 50.0) and (NUMBER_TRAINING_EPOCHS == 6)):
    END_OF_TRAINING = 300000 
    RUN_DURATION = 310000
elif ((EXAMPLE_TIME == 50.0) and (NUMBER_TRAINING_EPOCHS == 5)):
    END_OF_TRAINING = 250000 
    RUN_DURATION = 260000
elif ((EXAMPLE_TIME == 50.0) and (NUMBER_TRAINING_EPOCHS == 7)):
    END_OF_TRAINING = 350000 
    RUN_DURATION = 360000    
elif (EXAMPLE_TIME == 50.0):
    RUN_DURATION = 25000
    END_OF_TRAINING = 19000 
elif ((EXAMPLE_TIME == 100.0) and (NUMBER_TRAINING_EPOCHS == 6)):
    END_OF_TRAINING = 230000 
    RUN_DURATION = 280000

TIME_STEP = 1.0
FIRING_WEIGHT = 0.1
import pandas as pd
import numpy as np

#configration
import sys
#import cPickle as pickle

import pyNN.nest as sim

#EXAMPLE_TIME = 30.0
EXAMPLE_TIME = 50.0
NUMBER_TRAINING_EPOCHS = 5
#NUMBER_TRAINING_EPOCHS = 6
#NUMBER_TRAINING_EPOCHS = 7
if (EXAMPLE_TIME == 30.0):
    RUN_DURATION = 15000 #30
    END_OF_TRAINING = 12000 
elif ((EXAMPLE_TIME == 50.0) and (NUMBER_TRAINING_EPOCHS == 6)):
    END_OF_TRAINING = 300000 
    RUN_DURATION = 310000
elif ((EXAMPLE_TIME == 50.0) and (NUMBER_TRAINING_EPOCHS == 5)):
    END_OF_TRAINING = 250000 
    RUN_DURATION = 260000
elif ((EXAMPLE_TIME == 50.0) and (NUMBER_TRAINING_EPOCHS == 7)):
    END_OF_TRAINING = 350000 
    RUN_DURATION = 360000    
elif (EXAMPLE_TIME == 50.0):
    RUN_DURATION = 25000
    END_OF_TRAINING = 19000 
elif ((EXAMPLE_TIME == 100.0) and (NUMBER_TRAINING_EPOCHS == 6)):
    END_OF_TRAINING = 230000 
    RUN_DURATION = 280000
TIME_STEP = 1.0
FIRING_WEIGHT = 0.1

neuronsInFirstLayer = 10100
neuronsInSecondLayer = 4
inputFeatureBreadth = 3

firstSecond = -1 #global for printing out synaptic weights´kk

def init(): 
    sim.setup(timestep=TIME_STEP,min_delay=TIME_STEP,
                    max_delay=TIME_STEP, debug=0)
def createTrainSources(data):
    numberDataItems = len(data)

    start = 10.0
    learnOffset = 3
    epochTime = EXAMPLE_TIME*numberDataItems
    spikeSources = []
    inputSpikeTimesMatrix = []
    outputSpikeTimesMatrix = []
    for dataOffset in range (0,numberDataItems):
        #print data[dataOffset]
        inputSpikeTimes = []
        outputSpikeTimes = []

        for epoch in range (0,NUMBER_TRAINING_EPOCHS): 
            inputSpikeTime = start+(dataOffset*EXAMPLE_TIME)+(epoch*epochTime)
            inputSpikeTimes = inputSpikeTimes + [inputSpikeTime]
            outputSpikeTime = inputSpikeTime + learnOffset
            outputSpikeTimes = outputSpikeTimes + [outputSpikeTime]
        inputSpikeTimesMatrix = inputSpikeTimesMatrix + [inputSpikeTimes]
        outputSpikeTimesMatrix = outputSpikeTimesMatrix + [outputSpikeTimes]
    inputSpikeGens = sim.Population(numberDataItems,sim.SpikeSourceArray,
                {'spike_times': inputSpikeTimesMatrix},label="inputSpikes")

    outputSpikeGens = sim.Population(numberDataItems,sim.SpikeSourceArray,
                {'spike_times': outputSpikeTimesMatrix},label="outputSpikes")

    return [inputSpikeGens,outputSpikeGens,inputSpikeTimesMatrix,outputSpikeTimesMatrix]

def createDefaultNeurons(numberNeurons):
    cells=sim.Population(numberNeurons,sim.IF_cond_exp,cellparams={})
    return cells




def convertDataItemToSynapseDescription(dataLine,sourceNumber):
    inputConnector = []
    neuronsPerInputFeature = 101
    for dataFeature in range (0,100):
        dataFeatureValue = dataLine[dataFeature]
        for neuronOffset in range((int(dataFeatureValue) - inputFeatureBreadth),
                              (int(dataFeatureValue) + inputFeatureBreadth+1)):
            if ((neuronOffset >= 0) and (neuronOffset<neuronsPerInputFeature)):
                toNeuron = neuronOffset+(dataFeature*neuronsPerInputFeature)
                inputConnector = inputConnector + [(sourceNumber,toNeuron,
                        FIRING_WEIGHT,TIME_STEP)]

    return inputConnector

def connectInput(spikeSources, X,y,inputCells,outputCells):
    inputSpikeSources = spikeSources[0]
    outputSpikeSources = spikeSources[1]
    numberDataItems = len(X)
    for dataOffset in range (0,numberDataItems):
        dataItem = X[dataOffset]
        inputConnector=convertDataItemToSynapseDescription(dataItem,dataOffset)
        fromSource = dataOffset
        
        inputFromListConnector = sim.FromListConnector(inputConnector)
        sim.Projection(inputSpikeSources, inputCells, inputFromListConnector, 
                   receptor_type='excitatory')
         
        outputCategory = y[dataOffset]-1
        outputConnector = [(fromSource,outputCategory,FIRING_WEIGHT,
                            TIME_STEP)]
            
        outputFromListConnector = sim.FromListConnector(outputConnector)
        sim.Projection(outputSpikeSources, outputCells,outputFromListConnector, 
                   receptor_type='excitatory')

        
def createTestSources(data,startTime):
    numberDataItems = len(data)
    timeBetweenTests = 50
    spikeSources = []
    testSpikeTimesMatrix = []
    for dataOffset in range (0,numberDataItems):
        testSpikeTimes = [[startTime + (dataOffset*timeBetweenTests)]]
        testSpikeTimesMatrix = testSpikeTimesMatrix + testSpikeTimes

    testSpikeGens = sim.Population(numberDataItems,sim.SpikeSourceArray,
                {'spike_times': testSpikeTimesMatrix},label="testSpikes")

    return testSpikeGens,testSpikeTimesMatrix

def connectTest(testSpikeSources, data,inputCells):
    numberDataItems = len(data)
    for dataOffset in range (0,numberDataItems):
        dataItem = data[dataOffset]
        testConnector=convertDataItemToSynapseDescription(dataItem,dataOffset)
        testFromListConnector = sim.FromListConnector(testConnector)
        sim.Projection(testSpikeSources, inputCells, testFromListConnector, 
                   receptor_type='excitatory')
def connectFirstToSecondLayer(fromCells, toCells):
    global firstSecond
    connector = []
    stdp_model = sim.STDPMechanism(
        timing_dependence=sim.SpikePairRule(tau_plus=12.0,tau_minus=12.0,
                                            A_plus=0.003, A_minus=0.14),
        weight_dependence=sim.AdditiveWeightDependence(w_min=0.0, w_max=0.018),
        weight=0.0000,
        delay=1.0,
        dendritic_delay_fraction=float(1))

    firstSecond = sim.Projection(fromCells,toCells,
                   sim.AllToAllConnector(),
                   synapse_type = stdp_model)
    
def setupRecording(cells):
    cells.record({'spikes'})
def writeResults(simCells,file):
    simCells.write_data(file+".pkl",'spikes')
    #simCells.write_data(file+"V.pkl",'v')
    #simCells.write_data(file+"W.pkl",'w')


#trainData = np.load('trainData.txt',allow_pickle=True)
#classe = np.load('classe.txt',allow_pickle=True)
X_train = np.load('processed_data/X_train.npy',allow_pickle=True)
X_test = np.load('processed_data/X_test.npy',allow_pickle=True)
y_train = np.load('processed_data/y_train.npy',allow_pickle=True)
#X_train = np.round(X_train/5.13)
#X_test = np.round(X_test/5.13)
#testData = X_test
#trainData = X_train
init()
trainSpikeGenerators = createTrainSources(X_train)
testSpikeGenerators,h = createTestSources(X_test,END_OF_TRAINING)

firstLayerCells = createDefaultNeurons(neuronsInFirstLayer)
secondLayerCells = createDefaultNeurons(neuronsInSecondLayer)

connectInput(trainSpikeGenerators,X_train,y_train,firstLayerCells,secondLayerCells)
connectTest(testSpikeGenerators,X_test,firstLayerCells)
connectFirstToSecondLayer(firstLayerCells,secondLayerCells)
setupRecording(firstLayerCells)
setupRecording(secondLayerCells)
sim.run(RUN_DURATION)
#firstSecond.save('all','output/model.txt')
#writeResults(firstLayerCells,"output2/first")
writeResults(secondLayerCells,"output/second")
