import pandas as pd
import numpy as np
import sys

def get_spikes(path):
    
    pk = pd.read_pickle(path)
    segments = pk.segments
    segment = segments[0] 
    i=0
    spikeTrains = segment.spiketrains
    neurons = len(spikeTrains)
    neuron_arr = np.array([])
    spike_arr = np.array([])
    for neuronNum in range (0,neurons):
        if (len(spikeTrains[neuronNum])>0):
            spikes = spikeTrains[neuronNum]
            for spike in range (0,len(spikes)): 
                i = i+1
                #print(i)
                neuron_arr = np.append(neuron_arr,neuronNum)
                spike_arr = np.append(spike_arr,spikes[spike])
                #print (neuronNum, spikes[spike])
    spikes_df = pd.DataFrame({'neurons':neuron_arr,'spikes':spike_arr})
    return spikes_df

def get_spikes_array(df):

    spikeTimes = [[],[],[],[]]
    for i in range(0,4):
        spikeTimes[i] = df[df.neurons==i]['spikes'].values
    return spikeTimes

def convertTestSpikeTimesToPerExample(testSpikeTimes,testStartTime,exampleTime,numberItems):
    answer0 = np.zeros(numberItems)
    for spikeTimeOffset in range (0,len(testSpikeTimes[0])):
        actualSpikeTime = testSpikeTimes[0][spikeTimeOffset]
        baseTime = actualSpikeTime-testStartTime
        exampleOffset = baseTime/exampleTime
        exampleOffset = int (exampleOffset)
        if (exampleOffset >=0) and (exampleOffset < numberItems):
            answer0[exampleOffset] = answer0[exampleOffset] + 1
        elif(exampleOffset >= numberItems) :
             print ('firing beyond end in cat 1', actualSpikeTime)
            

    answer1 = np.zeros(numberItems)
    for spikeTimeOffset in range (0,len(testSpikeTimes[1])):
        actualSpikeTime = testSpikeTimes[1][spikeTimeOffset]
        baseTime = actualSpikeTime-testStartTime
        exampleOffset = baseTime/exampleTime
        exampleOffset = int (exampleOffset)
        #print actualSpikeTime,baseTime,exampleOffset
        if (exampleOffset >=0) and (exampleOffset < numberItems):
            answer1[exampleOffset] = answer1[exampleOffset] + 1
        elif(exampleOffset >= numberItems) :
             print ('firing beyond end in cat 1', actualSpikeTime)

    answer2 = np.zeros(numberItems)
    for spikeTimeOffset in range (0,len(testSpikeTimes[2])):
        actualSpikeTime = testSpikeTimes[2][spikeTimeOffset]
        baseTime = actualSpikeTime-testStartTime
        exampleOffset = baseTime/exampleTime
        exampleOffset = int (exampleOffset)
        #print actualSpikeTime,baseTime,exampleOffset
        if (exampleOffset >=0) and (exampleOffset < numberItems):
            answer2[exampleOffset] = answer2[exampleOffset] + 1
        elif(exampleOffset >= numberItems) :
             print ('firing beyond end in cat 1', actualSpikeTime)
    answer3 = np.zeros(numberItems)
    for spikeTimeOffset in range (0,len(testSpikeTimes[3])):
        actualSpikeTime = testSpikeTimes[3][spikeTimeOffset]
        baseTime = actualSpikeTime-testStartTime
        exampleOffset = baseTime/exampleTime
        exampleOffset = int (exampleOffset)
        #print actualSpikeTime,baseTime,exampleOffset
        if (exampleOffset >=0) and (exampleOffset < numberItems):
            answer3[exampleOffset] = answer3[exampleOffset] + 1
        elif(exampleOffset >= numberItems) :
            print ('firing beyond end in cat 4 ', actualSpikeTime)


    spikesPerExample = [answer0,answer1,answer2,answer3]
    return spikesPerExample
def return_classes(spikes_per_example):
    classes = np.argmax(spikes_per_example,axis=0)+1
    return classes
def get_classes(examples):
    df = pd.DataFrame({'1':examples[0],'2':examples[1],'3':examples[2],'4':examples[3]})
    classes = np.array([])
    for spikes in df.values:
        i=0
        values = [i for i in range(0,len(spikes)) if spikes[i]==max(spikes)]
        if len(values)==1:
            value = np.argmax(spikes)+1
            classes = np.append(classes,value)
            
        if len(values)==2:
            value = values[-1]+1
            classes = np.append(classes,value)
        if len(values)==3:
            value = 1
            classes = np.append(classes,value)
        if len(values)==4:
            value = 3
            classes = np.append(classes,value)
            
    return classes
    
args = sys.argv
numberArgs = args.__len__()
if (numberArgs == 2):
    fileName = args[1]
else:
    fileName = "output/second.pkl"
spikes_df = get_spikes(fileName)
spikes_array = get_spikes_array(spikes_df)
spikes_per_example = convertTestSpikeTimesToPerExample(spikes_array,250000,50,200)
classes = get_classes(spikes_per_example)
np.save('processed_data/X_predicted', classes, allow_pickle=True)
print(classes) 



